How to create a collaborative to-do list with JavaScript and Liveblocks

The goal of this tutorial is to show you how to build a collaborative to-do list app in 15 minutes. The to-dos will be persisted on Liveblocks backend and synced in real-time across clients. Users will also be able to see who’s currently using the app and when someone is typing.

We’re going to use vanilla JavaScript and esbuild for the bundling.

If you’re using a front-end framework such as React, we recommend reading one of our dedicated to-do list tutorials:

The source code for this guide is available on GitHub.

Install Liveblocks into your project

Install Liveblocks packages

Create an empty node project with npm init and run the following command to install Liveblocks package and esbuild:

$npm install @liveblocks/client esbuild

@liveblocks/client lets you interact with Liveblocks servers.
esbuild lets your bundle your app with @liveblocks/client.

Then add a build script to your package.json that will be responsible to bundle our app.

"scripts": {  "build": "esbuild app.js --bundle --outfile=static/app.js"},

Connect to Liveblocks servers

You’ll need an API key in order to use Liveblocks. Create a Liveblocks account to get your API key. It should start with pk_.

To connect to Liveblocks servers, create a client with createClient and set your public API key like below.

import { createClient } from "@liveblocks/client";
const client = createClient({ publicApiKey: "pk_prod_xxxxxxxxxxxxxxxxxxxxxxxx",});

Connect to a Liveblocks room

A room is the virtual space where people collaborate. To create a collaborative experience, you’ll need to connect your users to a Liveblocks room following the instructions below.

You can easily connect to a room by using client.enter by passing the room id as a parameter. For this tutorial we’ll use javascript-todo-app.

import { createClient } from "@liveblocks/client";
const client = createClient({ publicApiKey: "pk_prod_xxxxxxxxxxxxxxxxxxxxxxxx",});
function run() { const room = client.enter("javascript-todo-app", { initialPresence: { isTyping: false }, });}
run();

We’ve also passed an initialPresence value here—we’ll be using this later.

Show who’s currently in the room

Now that Liveblocks is set up, we’re going to use room.subscribe("others") to show who’s currently inside the room.

Create a file static/index.html with the following content:

<!DOCTYPE html><html lang="en">  <head>    <meta charset="utf-8" />    <title>Liveblocks - Todo list</title>    <link rel="stylesheet" href="index.css" />  </head>  <body>    <div class="container">      <div id="who_is_here" class="who_is_here"></div>    </div>    <script src="app.js"></script>  </body></html>

And replace app.js content with the code below, build your app with npm run build and open static/index.html in multiple browser windows.

import { createClient } from "@liveblocks/client";
const client = createClient({ publicApiKey: "pk_prod_xxxxxxxxxxxxxxxxxxxxxxxx",});
function run() { const room = client.enter("javascript-todo-app", { initialPresence: { isTyping: false }, });
const whoIsHere = document.getElementById("who_is_here");
room.subscribe("others", (others) => { whoIsHere.innerHTML = `There are ${others.count} other users online`; });}
run();

If you want to make your app feel less "brutalist" while following along, create a file static/index.css with the following CSS.

Show if someone is typing

Any users in the room can be typing, so we need to have a state isTyping per connected user. This state is only temporary, it is not persisted after users leave the room. Liveblocks has a concept of "presence" to handle this kind of temporary states. For example, a user "presence" can be used to share the cursor position or the selected shape if your building a design tool.

We’re going to use room.updatePresence hook to set the presence of the current user.

First, add an input to static/index.html

<!DOCTYPE html><html lang="en">  <head>    <meta charset="utf-8" />    <title>Liveblocks - Todo list</title>    <link rel="stylesheet" href="index.css" />  </head>  <body>    <div class="container">      <div id="who_is_here" class="who_is_here"></div>      <input id="todo_input" type="text" placeholder="What needs to be done?" />    </div>    <script src="app.js"></script>  </body></html>

Then listen to keydown and blur to detect when the user is typing.

import { createClient } from "@liveblocks/client";
const client = createClient({ publicApiKey: "pk_prod_xxxxxxxxxxxxxxxxxxxxxxxx",});
function run() { const room = client.enter("javascript-todo-app", { initialPresence: { isTyping: false }, });
const whoIsHere = document.getElementById("who_is_here"); const todoInput = document.getElementById("todo_input");
room.subscribe("others", (others) => { whoIsHere.innerHTML = `There are ${others.count} other users online`; });
todoInput.addEventListener("keydown", (e) => { // Clear the input when the user presses "Enter". // We'll add todo later on if (e.key === "Enter") { room.updatePresence({ isTyping: false }); todoInput.value = ""; } else { room.updatePresence({ isTyping: true }); } });
todoInput.addEventListener("blur", () => { room.updatePresence({ isTyping: false }); });}
run();

Now that we set the isTyping state when necessary, add a new div to display a message when at least one other user has isTyping equals to true.

<!DOCTYPE html><html lang="en">  <head>    <meta charset="utf-8" />    <title>Liveblocks - Todo list</title>    <link rel="stylesheet" href="index.css" />  </head>  <body>    <div class="container">      <div id="who_is_here" class="who_is_here"></div>      <input id="todo_input" type="text" placeholder="What needs to be done?" />      <div id="someone_is_typing" class="someone_is_typing"></div>    </div>    <script src="app.js"></script>  </body></html>
import { createClient } from "@liveblocks/client";
const client = createClient({ publicApiKey: "pk_prod_xxxxxxxxxxxxxxxxxxxxxxxx",});
function run() { const room = client.enter("javascript-todo-app", { initialPresence: { isTyping: false }, });
const whoIsHere = document.getElementById("who_is_here"); const todoInput = document.getElementById("todo_input"); const someoneIsTyping = document.getElementById("someone_is_typing");
room.subscribe("others", (others) => { whoIsHere.innerHTML = `There are ${others.count} other users online`;
someoneIsTyping.innerHTML = others .toArray() .some((user) => user.presence?.isTyping) ? "Someone is typing..." : ""; });
todoInput.addEventListener("keydown", (e) => { // Clear the input when the user presses "Enter". // We'll add todo later on if (e.key === "Enter") { room.updatePresence({ isTyping: false }); todoInput.value = ""; } else { room.updatePresence({ isTyping: true }); } });
todoInput.addEventListener("blur", () => { room.updatePresence({ isTyping: false }); });}
run();

Sync and persist to-dos

As opposed to the presence, some collaborative features require that every user interacts with the same piece of state. For example, in Google Doc, it is the paragraphs, headings, images in the document. In Figma, it’s all the shapes that make your design. That’s what we call the room’s storage.

The room’s storage is a conflicts-free state that multiple users can edit at the same time. It is persisted to our backend even after everyone leaves the room. Liveblocks provides custom data structures inspired by CRDTs that can be nested to create the state that you want.

  • LiveObject - Similar to JavaScript object. If multiple users update the same property simultaneously, the last modification received by the Liveblocks servers is the winner.
  • LiveList - An ordered collection of items synchronized across clients. Even if multiple users add/remove/move elements simultaneously, LiveList will solve the conflicts to ensure everyone sees the same collection of items.
  • LiveMap - Similar to a JavaScript Map. If multiple users update the same property simultaneously, the last modification received by the Liveblocks servers is the winner.

We’re going to store the list of todos in a LiveList. Initialize the storage with the initialStorage option when entering the room. Then we use LiveList.push when the user press "Enter".

import { createClient, LiveList } from "@liveblocks/client";
const client = createClient({ publicApiKey: "pk_prod_xxxxxxxxxxxxxxxxxxxxxxxx",});
async function run() { const room = client.enter("javascript-todo-app", { initialPresence: { isTyping: false }, initialStorage: { todos: new LiveList() }, });
const whoIsHere = document.getElementById("who_is_here"); const todoInput = document.getElementById("todo_input"); const someoneIsTyping = document.getElementById("someone_is_typing");
const { root } = await room.getStorage();
let todos = root.get("todos");
room.subscribe("others", (others) => { /* ... */ });
todoInput.addEventListener("keydown", (e) => { if (e.key === "Enter") { room.updatePresence({ isTyping: false }); todos.push({ text: todoInput.value }); todoInput.value = ""; } else { room.updatePresence({ isTyping: true }); } });
todoInput.addEventListener("blur", () => { room.updatePresence({ isTyping: false }); });}
run();

At this point, the todos are added to the storage but they are not rendered! Add a container for our todos and use room.subscribe(todos) to get rerender the app whenever the todos are updated.

<!DOCTYPE html><html lang="en">  <head>    <meta charset="utf-8" />    <title>Liveblocks - Todo list</title>    <link rel="stylesheet" href="index.css" />  </head>  <body>    <div class="container">      <div id="who_is_here" class="who_is_here"></div>      <input id="todo_input" type="text" placeholder="What needs to be done?" />      <div id="someone_is_typing" class="someone_is_typing"></div>      <div id="todos_container"></div>    </div>    <script src="app.js"></script>  </body></html>
import { createClient, LiveList } from "@liveblocks/client";
const client = createClient({ publicApiKey: "pk_prod_xxxxxxxxxxxxxxxxxxxxxxxx",});
async function run() { const room = client.enter("javascript-todo-app", { initialPresence: { isTyping: false }, initialStorage: { todos: new LiveList() }, });
const whoIsHere = document.getElementById("who_is_here"); const todoInput = document.getElementById("todo_input"); const someoneIsTyping = document.getElementById("someone_is_typing"); const todosContainer = document.getElementById("todos_container");
const { root } = await room.getStorage();
let todos = root.get("todos");
room.subscribe("others", (others) => { /* ... */ });
todoInput.addEventListener("keydown", (e) => { /* ... */ });
todoInput.addEventListener("blur", () => { /* ... */ });
function renderTodos() { todosContainer.innerHTML = "";
for (let i = 0; i < todos.length; i++) { const todo = todos.get(i);
const todoContainer = document.createElement("div"); todoContainer.classList.add("todo_container");
const todoText = document.createElement("div"); todoText.classList.add("todo"); todoText.innerHTML = todo.text; todoContainer.appendChild(todoText);
todosContainer.appendChild(todoContainer); } }
room.subscribe(todos, () => { renderTodos(); });
renderTodos();}
run();

Finally, add a delete button for each todo and call LiveList.delete to remove a todo from the list by index.

import { createClient, LiveList } from "@liveblocks/client";
const client = createClient({ publicApiKey: "pk_prod_xxxxxxxxxxxxxxxxxxxxxxxx",});
async function run() { const room = client.enter("javascript-todo-app", { initialPresence: { isTyping: false }, initialStorage: { todos: new LiveList() }, });
const whoIsHere = document.getElementById("who_is_here"); const todoInput = document.getElementById("todo_input"); const someoneIsTyping = document.getElementById("someone_is_typing"); const todosContainer = document.getElementById("todos_container");
const { root } = await room.getStorage();
let todos = root.get("todos");
room.subscribe("others", (others) => { /* ... */ });
todoInput.addEventListener("keydown", (e) => { /* ... */ });
todoInput.addEventListener("blur", () => { /* ... */ });
function renderTodos() { todosContainer.innerHTML = "";
for (let i = 0; i < todos.length; i++) { const todo = todos.get(i);
const todoContainer = document.createElement("div"); todoContainer.classList.add("todo_container");
const todoText = document.createElement("div"); todoText.classList.add("todo"); todoText.innerHTML = todo.text; todoContainer.appendChild(todoText);
const deleteButton = document.createElement("button"); deleteButton.classList.add("delete_button"); deleteButton.innerHTML = "✕"; deleteButton.addEventListener("click", () => { todos.delete(i); }); todoContainer.appendChild(deleteButton);
todosContainer.appendChild(todoContainer); } }
room.subscribe(todos, () => { renderTodos(); });
renderTodos();}
run();

In this tutorial, we discovered what’s a room, how to connect and enter a room. And how to use the room’s api to interact with its presence and storage.

You can see some stats about the room you created in your dashboard.

Liveblocks dashboard

Next steps

How to create a collaborative to-do list with React and Liveblocks

In this 15-minute tutorial, we’ll be building a collaborative to-do list using React and Liveblocks. As users edit the list, changes will be automatically synced and persisted, allowing for a list that updates in realtime across clients. Users will also be able to see who else is currently online, and when another user is typing.

This guide assumes that you’re already familiar with React, Next.js and TypeScript. If you’re using a state-management library such as Redux or Zustand, we recommend reading one of our dedicated to-do list tutorials:

The source code for this guide is available on GitHub.

Install Liveblocks into your project

Install Liveblocks packages

Create a new app with create-next-app:

$npx create-next-app@latest next-todo-list --typescript

Then run the following command to install the Liveblocks packages:

$npm install @liveblocks/client @liveblocks/react

Connect to Liveblocks servers

In order to use Liveblocks, we’ll need to sign up and get an API key. Create an account, then navigate to the dashboard to find your public key (it starts with pk_).

Let’s now add a new file liveblocks.config.ts at the root of your app to create a Liveblocks client, using the public key as shown below.

liveblocks.config.ts
import { createClient } from "@liveblocks/client";
const client = createClient({ publicApiKey: "",});

Connect to a Liveblocks room

Liveblocks uses the concept of rooms, separate virtual spaces where people can collaborate. To create a collaborative experience, multiple users must be connected to the same room.

Instead of using the client directly, we’re going to use createRoomContext from @liveblocks/react to create a RoomProvider and hooks to make it easy to consume from our components.

liveblocks.config.ts
import { createClient } from "@liveblocks/client";import { createRoomContext } from "@liveblocks/react";
const client = createClient({ publicApiKey: "",});
export const { suspense: { RoomProvider },} = createRoomContext(client);

You might be wondering why we’re creating our Providers and Hooks with createRoomContext instead of importing them directly from @liveblocks/client. This allows TypeScript users to define their Liveblocks types once in one unique location—providing a helpful autocompletion experience when using those hooks elsewhere.

We can now import the RoomProvider directly from our liveblocks.config.ts file. Every component wrapped inside RoomProvider will have access to the React hooks we’ll be using to interact with this room.

pages/index.tsx
import { RoomProvider } from "@/liveblocks.config";
export default function Page() { return <RoomProvider id="nextjs-todo-list">{/* ... */}</RoomProvider>;}

You may also notice that we’re exporting the suspense version of our hooks in liveblocks.config.ts. Because Next.js uses server-side rendering by default, we must wrap RoomProvider children in our ClientSideSuspense component. Liveblocks does not connect through WebSocket when running on server, so ClientSideSuspense ensure its children are not rendered on the server. More information can be found here.

pages/index.tsx
import { ClientSideSuspense } from "@liveblocks/react";import { RoomProvider } from "@/liveblocks.config";
export default function Page() { return ( <RoomProvider id="nextjs-todo-list"> <ClientSideSuspense fallback={<div>Loading...</div>}> <TodoList /> </ClientSideSuspense> </RoomProvider> );}
function TodoList() { return ( <div> {/* We’re starting to implement the to-do list in the next section */} </div> );}

Show who’s currently in the room

Now that Liveblocks is set up, we can start using the hooks to display how many users are currently online.

We’ll be doing this by adding useOthers, a selector hook that provides us information about which other users are online. First, let’s re-export it from liveblocks.config.ts. Because we’re using Suspense, we’ll be exporting all our hooks from the suspense property.

liveblocks.config.ts
//...
export const { suspense: { RoomProvider, useOthers, // 👈 },} = createRoomContext(client);

useOthers takes a selector function that receives an array, others, containing information about each user. We can get the current user count from the length of that array. Add the following code to pages/index.tsx, and open your app in multiple windows to see it in action.

pages/index.tsx
import { ClientSideSuspense } from "@liveblocks/react";import { RoomProvider, useOthers } from "@/liveblocks.config";
function WhoIsHere() { const userCount = useOthers((others) => others.length);
return ( <div className="who_is_here">There are {userCount} other users online</div> );}
function TodoList() { return ( <div className="container"> <WhoIsHere /> </div> );}
/* Page */

For a tidier UI, replace the content of styles/globals.css file with the following css.

Show if someone is typing

Next, we’ll add some code to show a message when another user is typing.

Any online user could start typing, and we need to keep track of this, so it’s best if each user holds their own isTyping property.

Luckily, Liveblocks uses the concept of presence to handle these temporary states. A user’s presence can be used to represent the position of a cursor on screen, the selected shape in a design tool, or in this case, if they’re currently typing or not.

Let’s define a new type Presence with the property isTyping in liveblocks.config.ts to ensure all our presence hooks are typed properly.

We can use the useUpdateMyPresence hook to change with the current user’s presence. But first, let’s re-export it from liveblocks.config.ts like we did previously with useOthers.

liveblocks.config.ts
// ...
type Presence = { isTyping: boolean;};
export const { suspense: { RoomProvider, useOthers, useUpdateMyPresence, // 👈 },} = createRoomContext<Presence>(client); // 👈

We can then call updateMyPresence whenever we wish to update the user’s current presence, in this case whether they’re typing or not.

pages/index.tsx
import { ClientSideSuspense } from "@liveblocks/react";import {  RoomProvider,  useOthers,  useUpdateMyPresence,} from "@/liveblocks.config";import { useState } from "react";
/* WhoIsHere */
function TodoList() { const [draft, setDraft] = useState(""); const updateMyPresence = useUpdateMyPresence();
return ( <div className="container"> <WhoIsHere /> <input type="text" placeholder="What needs to be done?" value={draft} onChange={(e) => { setDraft(e.target.value); updateMyPresence({ isTyping: true }); }} onKeyDown={(e) => { if (e.key === "Enter") { updateMyPresence({ isTyping: false }); setDraft(""); } }} onBlur={() => updateMyPresence({ isTyping: false })} /> </div> );}
/* Page */

Now that we’re keeping track of everyone’s state, we can create a new component called SomeoneIsTyping, and use this to display a message whilst anyone else is typing. To check if anyone is typing, we’re iterating through others and returning true if isTyping is true for any user.

pages/index.tsx
import { ClientSideSuspense } from "@liveblocks/react";import {  RoomProvider,  useOthers,  useUpdateMyPresence,} from "@/liveblocks.config";import { useState } from "react";
/* WhoIsHere */
function SomeoneIsTyping() { const someoneIsTyping = useOthers((others) => others.some((other) => other.presence.isTyping) );
return ( <div className="someone_is_typing"> {someoneIsTyping ? "Someone is typing..." : ""} </div> );}
function TodoList() { const [draft, setDraft] = useState(""); const updateMyPresence = useUpdateMyPresence();
return ( <div className="container"> <WhoIsHere /> <input {/* ... */ } /> <SomeoneIsTyping /> </div> );}
/* Page */

We also need to make sure that we pass an initialPresence for isTyping to RoomProvider.

pages/index.tsx
/* WhoIsHere *//* SomeoneIsTyping *//* TodoList */
export default function Page() { return ( <RoomProvider id="next-todo-list" initialPresence={{ isTyping: false }}> {/* ... */} </RoomProvider> );}

Sync and persist to-dos

To-do list items will be stored even after all users disconnect, so we won’t be using presence to store these values. For this, we need something new.

We’re going to use a LiveList to store the list of todos inside the room’s storage, a type of storage that Liveblocks provides. A LiveList is similar to a JavaScript array, but its items are synced in realtime across different clients. Even if multiple users insert, delete, or move items simultaneously, the LiveList will still be consistent for all users in the room.

First, let's declare a new type Storage in liveblocks.config.ts, like we did for Presence. This will ensure that our storage hooks are properly typed.

liveblocks.config.ts
import { createClient, LiveList } from "@liveblocks/client";
// ...
type Storage = { todos: LiveList<{ text: string }>;};
export const { suspense: { /* ... */ },} = createRoomContext<Presence, Storage>(client); // 👈

Go back to Page to initialize the storage with the initialStorage prop on the RoomProvider.

pages/index.tsx
/* ... */
import { LiveList } from "@liveblocks/client";
/* WhoIsHere *//* SomeoneIsTyping *//* TodoList */
export default function Page() { return ( <RoomProvider id="react-todo-app" initialPresence={{ isTyping: false }} initialStorage={{ todos: new LiveList() }} > {/* ... */} </RoomProvider> );}

Accessing storage

We’re going to use the useStorage hook to get the list of todos previously created. And once again, we’ll need to first re-export it from your liveblocks.config.

liveblocks.config.ts
// ...
export const { suspense: { RoomProvider, useOthers, useStorage, // 👈 useUpdateMyPresence, },} = createRoomContext<Presence, Storage>(client);

useStorage allows us to select part of the storage from the root level. We can find our todos LiveList at root.todos, and we can map through our list to display each item.

pages/index.tsx
import { ClientSideSuspense } from "@liveblocks/react";import {  RoomProvider,  useOthers,  useUpdateMyPresence,  useStorage} from "@/liveblocks.config";import { useState } from "react";import { LiveList } from "@liveblocks/client";
/* WhoIsHere *//* SomeoneIsTyping */
function TodoList() { const [draft, setDraft] = useState(""); const updateMyPresence = useUpdateMyPresence(); const todos = useStorage((root) => root.todos);
return ( <div className="container"> <WhoIsHere /> <input {/* ... */} onKeyDown={(e) => { if (e.key === "Enter") { updateMyPresence({ isTyping: false }); setDraft(""); } }} /> <SomeoneIsTyping /> {todos.map((todo, index) => { return ( <div key={index} className="todo_container"> <div className="todo">{todo.text}</div> <button className="delete_button" > ✕ </button> </div> ); })} </div> );}
/* Page */

Setting storage

To modify the list, we can use the useMutation hook. This is a hook that works similarly to useCallback, with a dependency array, allowing you to create a reusable storage mutation. Before we use this, first we need to re-export this from liveblocks.config.ts.

liveblocks.config.ts
// ...
export const { suspense: { RoomProvider, useMutation, // 👈 useOthers, useStorage, useUpdateMyPresence, },} = createRoomContext<Presence, Storage>(client);

useMutation gives you access to the storage root, a LiveObject. From here we can use LiveObject.get to retrieve the todos list, then use LiveList.push and LiveList.delete to modify our todo list. These functions are then passed into the appropriate events.

pages/index.tsx
import { ClientSideSuspense } from "@liveblocks/react";import {  RoomProvider,  useOthers,  useUpdateMyPresence,  useStorage,  useMutation} from "@/liveblocks.config";import { useState } from "react";import { LiveList } from "@liveblocks/client";
/* WhoIsHere *//* SomeoneIsTyping */
export default function TodoList() { const [draft, setDraft] = useState(""); const updateMyPresence = useUpdateMyPresence(); const todos = useStorage((root) => root.todos);
const addTodo = useMutation(({ storage }, text) => { storage.get("todos").push({ text }) }, []);
const deleteTodo = useMutation(({ storage }, index) => { storage.get("todos").delete(index); }, []);
return ( <div className="container"> <WhoIsHere /> <input {/* ... */}
onKeyDown={(e) => { if (e.key === "Enter") { updateMyPresence({ isTyping: false }); addTodo(draft); setDraft(""); } }} /> <SomeoneIsTyping /> {todos.map((todo, index) => { return ( <div key={index} className="todo_container"> <div className="todo">{todo.text}</div>
<button className="delete_button" onClick={() => deleteTodo(index)} > ✕ </button>
</div> ); })} </div> );}
/* Page */

Voilà! We have a working collaborative to-do list, with persistent data storage.

Summary

In this tutorial, we’ve learnt about the concept of rooms, presence, and others. We’ve also learnt how to put all these into practice, and how to persist state using storage too.

You can see some stats about the room you created in your dashboard.

Liveblocks dashboard

Next steps

We use cookies to collect data to improve your experience on our site. Read our Privacy Policy to learn more.